#!/usr/bin/perl
#
#    admin.pl - NMIS Perl Program - Network Mangement Information System
#    Copyright (C) 2000 Sinclair InterNetworking Services Pty Ltd
#    Keith Sinclair <keith@sinclair.org.au>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#*****************************************************************************
use lib "/usr/share/nmis/lib";

my $configfile = "/etc/nmis/nmis.conf";
# 
#****** Shouldn't be anything else to customise below here *******************

use strict;
use web;
use NMIS;
 
#
# This reads in the information sent when the user pressed Submit
#
my ($name, $value, $pair, %FORM);

my $buffer = $ENV{'QUERY_STRING'};
my @pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);

    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    $FORM{$name} = $value;
}

# Break the queary up for the names
my $node = $FORM{node};
my $admin = $FORM{admin};
my $space = $FORM{space};
my $summary = $FORM{summary};
my $firstname = $FORM{firstname};
my $surname = $FORM{surname};
my $username = $FORM{username};
my $group = $FORM{group};
my $action = $FORM{action};
my $makeitso = $FORM{makeitso};
# Allow program to use other configuration files
if ( $FORM{file} ne "" ) { $configfile = $FORM{file}; }

if ( $admin eq "" ) { $admin = $FORM{tool}; }

loadConfiguration($configfile);

my $scriptname = $NMIS::config{admin};

my $datestamp=NMIS::returnDateStamp;
my $adminoutput;

if ( $action ne "" ) { $admin = "newuser"; }

# Select function to be performed
if ($admin eq "") {
	pageStart("Admin Menu","false");
	tableStart;

	&adminMenu; 

	tableEnd;
	pageEnd;
}
else { 
	if ($admin eq "ping") {
		$adminoutput=`/usr/sbin/ping -s $node 64 5`;
	}
	elsif ($admin eq "trace") {
		$adminoutput=`/opt2/CSCOpx/bin/traceroute $node`;
	}
	elsif ($admin eq "nslookup") { $adminoutput=`/usr/sbin/nslookup $node`; }
	elsif ($admin eq "finger") { $adminoutput=`/usr/bin/finger \@$node`; }
	elsif ($admin eq "who") { $adminoutput=`/usr/bin/who`; }
	elsif ($admin eq "man") { $adminoutput=`/usr/bin/man $node`; }
	elsif ($admin eq "mank") { $adminoutput=`/usr/bin/man -k $node`; }
	elsif ($admin eq "ps") { $adminoutput=`/usr/bin/ps -ef`; }
	elsif ($admin eq "iostat") { $adminoutput=`/usr/bin/iostat 1 10`; }
	elsif ($admin eq "vmstat") { $adminoutput=`/usr/bin/vmstat 1 10`; }
	elsif ($admin eq "df") { $adminoutput=`/usr/bin/df -k`; }
	elsif ($admin eq "nodes") { $adminoutput=`cat /data/files/nodes.dat`; }
	elsif ($admin eq "logs") { $adminoutput=`cat /data/files/log.dat`; }
	elsif ($admin eq "cisco") { 
		if ($node eq "" ) {
			$adminoutput=`/usr/bin/tail -250 /data/log/cisco.log |sort -M -r`;
		}
		else {
			$adminoutput=`/usr/bin/grep -i "$node" /data/log/cisco.log|tail -250 |sort -M -r`;
		}
	} 
	elsif ($admin eq "event") { 
		if ($node eq "" ) {
			$adminoutput=`/usr/bin/tail -250 /data/log/event.log |sort -M -r`;
		}
		else {
			$adminoutput=`/usr/bin/grep -i "$node" /data/log/event.log|tail -100 |sort -M -r`;
		}
	} 
	elsif ($admin eq "syslog") { $adminoutput=`/usr/bin/tail -250 /var/log/syslog |sort -M -r`; } 
	elsif ($admin eq "messages") { $adminoutput=`/usr/bin/tail -250 /var/adm/messages |sort -M -r`; } 
	elsif ($admin eq "newuser") { 
		if ( $ENV{'REMOTE_USER'} =~ /hligonis|ksinclai/ ) { &newUser; }
	 	$adminoutput="Not allowed by this user";
	}

	
	pageStart("Admin","false");
	tableStart;

	&adminMenu; 

    	headerBar("$admin results for $node at $datestamp");
	print "<td COLSPAN=9 bgcolor=#FFFFFF><font color=#000000><pre>\n$adminoutput\n</pre></font></td>";
	tableEnd;
	pageEnd;
	exit;

}

sub adminMenu {
print <<EOF;
<FORM ACTION="$scriptname">
<TR>
	<TH bgcolor="#FFFFFF"><INPUT TYPE=submit VALUE="GO"></TH>
	<TD bgcolor="#FFFFFF">Tool Name </TD><TD bgcolor="#FFFFFF">
		<SELECT NAME=admin SIZE=1>
	            <option value="$admin">$admin</option>
	            <option value="cisco">cisco log</option>
	            <option value="event">event log</option>
	            <option value="newuser">newuser</option>
	            <option value="log">log list</option>
	            <option value="nodes">node list for Stats</option>
	            <option value="man">man</option>
	            <option value="mank">man -k</option>
	            <option value="df">df -k</option>
	            <option value="ps">ps -ef</option>
	            <option value="iostat">iostat 1 10</option>
	            <option value="vmstat">vmstat 1 10</option>
	            <option value="who">who</option>
	            <option value="syslog">syslog</option>
	            <option value="messages">messages</option>
	            <option value="finger">finger</option>
	            <option value="ping">ping</option>
	            <option value="trace">traceroute</option>
	            <option value="nslookup">nslookup</option>
		</SELECT>
	</TD>
	<TD bgcolor="#FFFFFF">Input</TD><TD bgcolor="#FFFFFF"><INPUT NAME=node VALUE="$node"></TD>
</TR>
</FORM> 
EOF
}

sub newUser {
	my $out;
	my $user;
	my $command;
	my %passwdHash;
	
	# Remove offending characters from namestring
	$firstname =~ s/ |\'|\"|-|_|\.//g;
	$surname =~ s/ |\'|\"|-|_|\.//g;

	my $newuser = lc(substr($firstname,0,1)).lc(substr($surname,0,7));
	
	if ($action eq "" ) {
		pageStart("Admin Menu - New User","false");
		tableStart;

		&adminMenu; 

		headerBar("Adding or Deleting a User");
		&newUserMenu;

		tableEnd;
		pageEnd;
		exit 0;
	}
	else {
		pageStart("Admin Menu - New User","false");
		tableStart;

		&adminMenu; 

		headerBar("Adding or Deleting a User");

		&newUserMenu;

		rowStart;
		cellStart("#FFFFFF",7);

			if ( $action eq "add" ) {
				$command = "/usr/bin/sudo /usr/sbin/useradd -c \"$firstname $surname\" -d /export/home/$newuser -g $group -s /usr/bin/ksh $newuser";

			}
			elsif ( $action eq "delete" ) {
				$command = "/usr/bin/sudo /usr/sbin/userdel $username";
			}
			
			if ( $makeitso eq "true" ) {
				# Execute the command to add or delete the user
				$out = `$command`;

				# Bit of Basic Error checking
				if ( $out ne "" ) {
					print "There may have been a problem better look into it!<BR>";
					print "command output:<BR>$out<BR>";
				}
				else {
					if ( $action eq "add" ) { 
						print "User Added: $newuser<BR>"; 
						print "<P>Don't forget to set the password: \"passwd $newuser\"<BR>";
					}
					elsif ( $action eq "delete" ) { 
						print "User Deleted: $username<BR>"; 
						print "<P>Don't forget to remove the home directory<BR>";
					}
				}

				# Make the home Directory
				$command = "/usr/bin/mkdir /export/home/$newuser";
				$out = `$command`;
				if ( $out ne "" ) {
					print "There may have been a problem better look into it!<BR>";
					print "command = $command<BR>";
					print "output:<BR>$out<BR>";
				}
				
				# Change permissions on the directory
				$command = "\/usr\/bin\/chown -R $newuser \/export\/home\/$newuser; \/usr\/bin\/chmod -R u+wr g+r o-rwx \/export\/home\/$newuser";
				$out = `$command`;
				if ( $out ne "" ) {
					print "There may have been a problem better look into it!<BR>";
					print "command = $command<BR>";
					print "output:<BR>$out<BR>";
				}
			} 
			else {
				if ( $action eq "add" ) {
					print "<STRONG>Adding User</STRONG><BR>";
					print "username = $newuser<BR>";
					print "Group = $group<BR>";
					print "Description = \"$firstname $surname\"<BR>";
					print "Home = \/export\/home\/$newuser<BR>";
 					print "Shell = \/usr\/bin\/ksh<BR>";
 					print "<BR>";
				 	print "<A HREF=\"$scriptname?action=$action&firstname=$firstname&surname=$surname&group=$group&makeitso=true\">\"MAKE IT SO\"</A>";
			}
				elsif ( $action eq "delete" ) {
					print "<STRONG>Deleting User</STRONG><BR>";
					print "username = $username<BR>";
					print "<BR>";
				 	print "<A HREF=\"$scriptname?action=$action&username=$username&makeitso=true\">\"MAKE IT SO\"</A>";
				}
				
			}
		cellEnd;
		rowEnd;
		rowStart;
		cellStart("#FFFFFF",7);

			print "<STRONG>Password File Contents</STRONG>";

			%passwdHash = NMIS::readPasswordFile;
			preStart;			
			foreach $user (sort ( keys (%passwdHash) ) )  {
		                print "$user uid=$passwdHash{$user}{uid} gid=$passwdHash{$user}{gid} shell=$passwdHash{$user}{shell} home=$passwdHash{$user}{home}\n";
			}
			preEnd;			

		cellEnd;
		rowEnd;

		tableEnd;
		pageEnd;
		exit 0;
	}
}
sub newUserMenu {
	my $user;
	my %groupHash;
	my %passwdHash;
	
	%passwdHash = NMIS::readPasswordFile;
	%groupHash = NMIS::readGroupFile;

print<<EOF;
<FORM ACTION="$scriptname">
<TR>
	<TH bgcolor="#FFFFFF"><INPUT TYPE=submit VALUE="ACTION"></TH>
	<TD bgcolor="#FFFFFF">
		Action<BR>
		<SELECT NAME=action SIZE=1>
	            <option value="add">add</option>
        	    <option value="delete">delete</option>
		</SELECT>
	</TD>
	<TD bgcolor="#FFFFFF">
		Group<BR>
		<SELECT NAME=group SIZE=1>
	            <option value="nws">nws</option>
	            <option value="img">img</option>
        	    <option value="guest">guest</option>
		</SELECT>
	</TD>
	<TD bgcolor="#FFFFFF">
		username<BR>
	     	<SELECT NAME=username SIZE=1>
	            <OPTION VALUE=""></OPTION>
EOF
        foreach $user (sort ( keys (%passwdHash) ) )  {
		if (	( $groupHash{nws}{gid} eq $passwdHash{$user}{gid} ) ||
			( $groupHash{guest}{gid} eq $passwdHash{$user}{gid} ) ||
			( $groupHash{img}{gid} eq $passwdHash{$user}{gid} ) 
		) {
	                print "<OPTION VALUE=\"$user\">$user</OPTION>\n";
        	}

	}

	print <<EOF;
		</SELECT>
	</TD>
	<TD bgcolor="#FFFFFF">First Name<BR><INPUT NAME=firstname VALUE="$firstname"></TD>
	<TD bgcolor="#FFFFFF">Surname<BR><INPUT NAME=surname VALUE="$surname"></TD>
</TR>
</FORM> 
EOF
}

exit(0);


