#!/usr/bin/perl
#
#    logs.pl - NMIS CGI Program - Network Mangement Information System
#    Copyright (C) 2000 Sinclair InterNetworking Services Pty Ltd
#    Keith Sinclair <keith@sinclair.org.au>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#*****************************************************************************
# Auto configure to the <nmis-base>/lib and <nmis-base>/files/nmis.conf
use lib "/usr/share/nmis/lib";

# 
#****** Shouldn't be anything else to customise below here *******************

use strict;
use web;
use func;
use csv;
use NMIS;

# This reads in the information sent when the user pressed Submit
my %FORM = getCGIForm($ENV{'QUERY_STRING'});

# Break the queary up for the names
my $logShort = $FORM{log};
my $search = $FORM{search};
my $sort = $FORM{sort};
my $lines = $FORM{lines};
my $legend = $FORM{legend};
my $level = $FORM{level};

if ( $legend eq "" ) { $legend = "false"; }
if ( $sort eq "" ) { $sort = "descending"; }
if ( $lines eq "" ) { $lines = 100; }

# Allow program to use other configuration files
my $conf;
if ( $FORM{file} ne "" ) { $conf = $FORM{file}; }
else { $conf = "nmis.conf"; }
my $configfile = "/etc/nmis/$conf";
if ( -f $configfile ) { loadConfiguration($configfile); }
else { die "Can't access configuration file $configfile.\n"; }

my $nmis_url = "<a href=\"$NMIS::config{nmis}?file=$conf\"><img alt=\"NMIS Dash\" src=\"$NMIS::config{nmis_icon}\" border=\"0\"></a>";
my $back_url = "<a href=\"$ENV{HTTP_REFERER}\"><img alt=\"Back\" src=\"$NMIS::config{back_icon}\" border=\"0\"></a>";
my $logs_url = "<a href=\"$ENV{SCRIPT_NAME}\"><img alt=\"Logs\" src=\"$NMIS::config{logs_icon}?file=$conf\" border=\"0\"></a>";

my %logList;

my @table;

my $firstdate;
my $lastdate;
my $title;
my $span = 1;

$search =~ s/ and /\+/gi;
$search =~ s/ /\+/gi;

%logList = loadCSV($NMIS::config{Logs_Table},$NMIS::config{Logs_Key},"\t");

$logShort =~ s/\+/ /gi;
my $logLC = lc($logShort);
my $log = $logList{$logLC}{file};

# Select function to be performed
if ($logShort ne "") {
	$span = 2;
	$title = "logs: $logShort - Search \"$search\"";
	pageStartCSS($title,$NMIS::config{styles});
	&loadLogFile($log);
	&cssTableStart("");
	&logMenuSmall;
	if ($legend eq "true" ) { &displayLegend; }
	&displayLogFile;
	&tableEnd;
	&pageEnd;
}
else {
	# No options so give 'em a menu of sorts
	$span = 1;
	$title = "Log List";
	$logShort = "Cisco_Syslog";
	pageStartCSS($title,$NMIS::config{styles});
	&cssTableStart("");
	&logMenuSmall;
	if ($legend eq "true" ) { &displayLegend; }
	&headerBar("Log List",1);
	&logMenuLarge;
	&tableEnd;
	&pageEnd;
}

exit(0);

sub logMenuSmall {

	my $logName;
	my $logChoice;
	my $levelChoice;
	my $linesChoice;

	if ( $logShort eq "" ) { $logChoice = "Cisco_Syslog"; }
	else { $logChoice = $logShort; } 

	if ( $lines eq "" ) { $linesChoice = 250; }
	else { $linesChoice = $lines; } 

	if ( $level eq "" ) { $levelChoice = "Normal"; }
	else { $levelChoice = $level; } 

	print <<EOF;
<tr>
<td class="grey" colspan="$span">
<table class="menu1">
<tr>
<FORM ACTION="$ENV{SCRIPT_NAME}">
	<th class="menugrey">$back_url$nmis_url$logs_url</th>
	<th class="menugrey"><INPUT TYPE=submit value="GO"></th>
	<td class="menugrey">
		Log Name 
		<select NAME=log SIZE=1>
		<option value="$logChoice">$logChoice</option>
		<option value="Cisco_Syslog">Cisco_Syslog</option>
		<option value="Event_Log">Event_Log</option>
		<option value="NMIS_Log">NMIS_Log</option>
EOF
        foreach $logName (sort ( keys (%logList) ) )  {
		if ( $logName ne "Cisco_Syslog" and $logName ne "Event_Log" and $logName ne "NMIS_Log" ) {
	                print "\t\t<option value=\"$logList{$logName}{log}\">$logList{$logName}{log}</option>\n";
		}
	}

	print <<EOF;
		</select>
	</td>
	<td class="menugrey">Search String 
		<INPUT NAME=search value="$search">
	</td>
	<td class="menugrey">
		Lines 
		<select NAME=lines SIZE=1>
		<option value="$linesChoice">$linesChoice</option>
		<option value="50">50</option>
		<option value="100">100</option>
		<option value="250">250</option>
		<option value="500">500</option>
		<option value="1000">1000</option>
		<option value="2000">2000</option>
		<option value="3000">3000</option>
		<option value="4000">4000</option>
		<option value="5000">5000</option>
		<option value="7500">7500</option>
		<option value="10000">10000</option>
		</select>
	</td>
	<td class="menugrey">
		Level 
		<select NAME=level SIZE=1>
		<option value="$levelChoice">$levelChoice</option>
		<option value="normal">Normal</option>
		<option value="warning">Warning</option>
		<option value="minor">Minor</option>
		<option value="major">Major</option>
		<option value="critical">Critical</option>
		</select>
	</td>
	<td class="menugrey">
		Sorting 
		<select NAME=sort SIZE=1>
		<option value="descending">descending</option>
		<option value="ascending">ascending</option>
		</select>
	</td>
</form> 
</tr>
</table>
</td>
</tr>

EOF
}

sub logMenuLarge {
	my $logName;
	my @filestat;
	my $date;
	my $options = "&sort=descending&lines=250&level=normal";

	print "<td class=\"white\">\n";
	print "<table class=\"white\">\n";
	print "<tr><th class=\"grey\">Description</th><th class=\"grey\">File</th><th class=\"grey\">Size</th><th class=\"grey\">Date</th></tr>\n";
        foreach $logName (sort ( keys (%logList) ) )  {
        	if ( $logList{$logName}{file} ne "" ) {
	        	@filestat = stat $logList{$logName}{file};
	        	$date = func::returnDateStamp(@filestat[9]);
	      		print <<EO_HTML;
			<tr>
			<td><a href="$ENV{SCRIPT_NAME}?file=$conf&log=$logList{$logName}{log}$options">$logList{$logName}{log}</a></td>
			<td>$logList{$logName}{file}</td>
			<td align="right">$filestat[7] bytes</td>
			<td>$date</td>
			</TR>
EO_HTML
		}
        }
	print "</td>\n</table>\n";
}

sub headerBar {
  	my $string = shift;
  	my $colspan = shift;

	if ( $colspan eq "" ) { $colspan = "COLSPAN=1"; }
	else { $colspan = "COLSPAN=$colspan"; }

	print "<tr>\n";
	print "<td class=\"grey\" $colspan>$string</td>\n";
	print "</tr>\n";
}

sub loadLogFile {
	my $file = shift;
	my $boolean;
	my $dosearch;
	my $search1;
	my $search2;
	my $search3;
	my $search4;
	my $search5;
	my @tmpsearch;
	my $index;

 	# Open the table and and store in arrays
	$index=0;

	if ( $search eq "" ) { 
		$dosearch = "false"; 
		$boolean = "false";
	}
	elsif ( $search =~ /\+/ ) {
		$boolean = "true";
		($search1,$search2,$search3,$search4,$search5) = split(/\+/,$search);
	}

	#print STDERR "DEBUG: logShort=$logShort log=$log search=$search boolean=$boolean search1=$search1 search2=$search2 search3=$search3\n";

	open (DATA, $file) || print STDERR time." Cannot open the file=$file log=$logShort. $!\n";

	# find the line with the entry in and store in the array
	while (<DATA>) {
		chomp;
		if ( $boolean eq "true" ) {
			if ( 	$_ =~ /$search1/i and 
				$_ =~ /$search2/i and 
				$_ =~ /$search3/i and 
				$_ =~ /$search4/i and 
				$_ =~ /$search5/i 
			) {
				@table[$index] = $_;
				++$index;
			}
		}
		elsif ( $dosearch eq "false" ) {
			@table[$index] = $_;		      
			++$index;
		}
		elsif ( $_ =~ /$search/i ) {
			@table[$index] = $_;
			++$index;
		}
	}
}

sub displayLogFile {

	my $stop;
	my $numlines;
	my $index;

	my $linelink50;
	my $linelink100;
	my $linelink250;
	my $linelink500;
	my $linelink1000;
	my $linelink2000;
	my $levellinkCritical;
	my $levellinkMajor;
	my $levellinkMinor;
	my $levellinkWarning;
	my $levellinkNormal;
	my $critical = NMIS::eventColor("critical");
	my $major = NMIS::eventColor("major");
	my $minor = NMIS::eventColor("minor");
	my $warning = NMIS::eventColor("warning");
	my $error = NMIS::eventColor("error");
	my $normal = NMIS::eventColor("normal");

	# Store total number of lines in array + 1 in var
	$numlines = $#table + 1;

	$linelink50 = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\">50</a>";
	$linelink50 =~ s/lines=$lines/lines=50/g ;
	$linelink100 = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\">100</a>";
	$linelink100 =~ s/lines=$lines/lines=100/g ;
	$linelink250 = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\">250</a>";
	$linelink250 =~ s/lines=$lines/lines=250/g ;
	$linelink500 = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\">500</a>";
	$linelink500 =~ s/lines=$lines/lines=500/g ;
	$linelink1000 = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\">1000</a>";
	$linelink1000 =~ s/lines=$lines/lines=1000/g ;
	$linelink2000 = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\">2000</a>";
	$linelink2000 =~ s/lines=$lines/lines=2000/g ;
	$levellinkCritical = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\"><FONT COLOR=$critical>Critical</FONT></a>";
	$levellinkCritical =~ s/level=$level/level=critical/g ;
	$levellinkMajor = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\"><FONT COLOR=$major>Major</FONT></a>";
	$levellinkMajor =~ s/level=$level/level=major/g ;
	$levellinkMinor = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\"><FONT COLOR=$minor>Minor</FONT></a>";
	$levellinkMinor =~ s/level=$level/level=minor/g ;
	$levellinkWarning = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\"><FONT COLOR=$warning>Warning</FONT></a>";
	$levellinkWarning =~ s/level=$level/level=warning/g ;
	$levellinkNormal = "<a href=\"$ENV{SCRIPT_NAME}?file=$conf&$ENV{'QUERY_STRING'}\"><FONT COLOR=$normal>Normal</FONT></a>";
	$levellinkNormal =~ s/level=$level/level=normal/g ;
	
	&headerBar("$title - Lines \n$linelink50 \n$linelink100 \n$linelink250 \n$linelink500 \n$linelink1000 \n$linelink2000 \n$levellinkNormal \n$levellinkWarning \n$levellinkMinor \n$levellinkMajor \n$levellinkCritical",$span);

	if ( $sort =~ /descending/) {

		if ($lines != "") {
			if ($numlines > $lines ) {
				$stop = $#table + 1 - $lines;
			}
			else { $stop = 0; }
		}

    		for ($index = $numlines - 1 ; $index > $stop - 1; --$index) { 
	      		&outputLine(@table[$index]);
		}
	}
	# Must be ascending or default
	else {
		# if $lines = "" then do nothing otherwise set the number of lines to be displayed to be $lines
		if ($lines != "") {
			if ($numlines > $lines ) {
				$numlines = $lines;
			}
		}
		for ($index = 0; $index < $numlines; ++$index) { 
	      		&outputLine(@table[$index]);
		}
	}	
}

sub outputLine
{
  	my $line = shift;

	my @logline;
	my $colspan;
	my $eventlink;
	my $nodelink;
	my $buttons;
	my $llasttime;
	my $lstarttime;
	my $ldetails;
	my $levent_level;
	my $eventClass;
	my $eventlevellink;
	my $levent;
	my $lnode;
	my $lsub;
	my $shortnode;
	my $ltime;
	my $sizetag;
	my $eventColor;
	my $datestamp;
	my $datestamp_current;
	my $datestamp_start;
	my $outage;
	my $tics;
	my @x;
	my $event;
	my $desc;
	my $i;
	my @eventlist;
	my @otherline;
	my $count_space;
	my $count_colon;
	my $print = "false";

	# If its the event log and there are comma's insert a link to the node and customer specific alerts.
	# evaluate each line to determine what it is, ie cisco syslog, or something else.
	#$count_space = tr/ //;      
	#$count_colon = tr/://;

	# it is a syslog of some description.
	if ( $line =~ /%/ and $line =~ /:/ ) {
		$line =~ s/  / /g;	
		@otherline = split("%",$line);
		$event = "%".$otherline[1];
		@otherline = split(":",$event);
		$event = $otherline[0];
		shift @otherline;
		$desc = join(":", @otherline);
		# now we have the event and the description.
		#print STDERR "event=$event desc=$desc\n";
		
		@logline = split(" ",$line);

		# Get the shortnode name out.
		$shortnode = $logline[3];
		#Dispose of the domainname!
		if ( $shortnode !~ /^\[/ ) {
			@x = split(/\./,$logline[3]);
			#Check if it is an IP address or not.
			if ( $x[0] !~ /\d+/ ) {	$shortnode = $x[0]; }
			$lnode = $logline[3];
		}
		else {
			# Could do DNS reverse lookup to resolve to name! 
			# Probably better not to, slower if no entries exist.
			$logline[3] =~ s/\[|\]//g;
			@x = split(/\./,$logline[3]);
			$shortnode = "$x[0].$x[1].$x[2].$x[3]";
			$lnode = $shortnode;
		}
		@x = split("--",$shortnode);
		$shortnode = $x[0];
		
		if ( $event =~ /^%/ ) {
			if ( $firstdate eq "" ) { $firstdate = "$logline[0] $logline[1] $logline[2]"; }
			else { $lastdate = "$logline[0] $logline[1] $logline[2]"; }
			@eventlist = split("-",$event);
			
			if ( $desc =~ /state to up|new adjacency|is up|state changed to ACTIVE/i ) {
				$levent_level = "normal";
			}
			else {
				$levent_level = $eventlist[1];
			}
		}
		elsif ( $line =~ /Traceback/ ) {
			$lnode = $logline[3];
			$event = "Traceback";
			$levent_level = "critical";
		}
		else {
			$levent_level = "unknown";
		}
	
		if ( $event ne "" and $lnode ne "" ) {
			# Do some quick stats
		
			$eventlink="<a href=\"$ENV{SCRIPT_NAME}?file=$conf&log=$logShort&sort=descending&search=$event&lines=$lines&level=$level\">$event</a>";
	
			$buttons=
				"<a href=\"$NMIS::config{admin}?tool=ping&node=$lnode\"><img alt=\"ping $lnode\" src=\"$NMIS::config{ping_icon}\" border=\"0\"></a>".
				"<a href=\"$NMIS::config{admin}?tool=trace&node=$lnode\"><img alt=\"traceroute $lnode\" src=\"$NMIS::config{trace_icon}\" border=\"0\"></a>".
				"<a href=\"telnet://$lnode\"><img alt=\"telnet to $lnode\" src=\"$NMIS::config{telnet_icon}\" border=0 align=top></a>".
				"<a href=\"/cgi-nmis/nmiscgi.pl?node=$lnode\"><img alt=\"NMIS\" src=\"$NMIS::config{nmis_icon}\" border=\"0\"></a>".
			"";
			if ( $lnode !~ /\[(.*)\]/ ) {
				$nodelink="<a href=\"$ENV{SCRIPT_NAME}?file=$conf&log=$logShort&sort=descending&search=$shortnode&lines=$lines&level=$level\">$shortnode</a>";
				$line =~ s/$lnode/$nodelink/g;
			}
			$line = "$line";
			$line =~ s/$event/$eventlink/g;
		}

		$colspan = 1;
		$eventColor = func::eventColor($levent_level);
	} # elsif cisco.log 
	elsif ( ( $log =~ /event(.*)log/ ) and ( $line =~ /,/ ) ) {
		$line =~ s/, /,/g;
		($ltime,$lnode,$levent,$levent_level,$ldetails) = split(/,/,$line);
		#Check the date format and if it doesn't have a - then it is UNIX format
		if ( $ltime !~ /-/ ) { 
			$ltime = NMIS::returnDateStamp("$ltime");
		}

		$buttons=
			"<a href=\"$NMIS::config{admin}?tool=ping&node=$lnode\"><img alt=\"ping\" src=\"$NMIS::config{ping_icon}\" border=\"0\"></a>".
			"<a href=\"$NMIS::config{admin}?tool=trace&node=$lnode\"><img alt=\"traceroute\" src=\"$NMIS::config{trace_icon}\" border=\"0\"></a>".
			"<a href=\"telnet://$lnode\"><img alt=\"telnet\" src=\"$NMIS::config{telnet_icon}\" border=\"0\"></a>".
			"<a href=\"/cgi-nmis/nmiscgi.pl?node=$lnode\"><img alt=\"NMIS\" src=\"$NMIS::config{nmis_icon}\" border=\"0\"></a>"
		;
		$nodelink="<a href=\"$ENV{SCRIPT_NAME}?file=$conf&log=$logShort&sort=descending&search=$lnode&level=$level\">$lnode</a>";
		$eventlink="<a href=\"$ENV{SCRIPT_NAME}?file=$conf&log=$logShort&sort=descending&search=$levent&level=$level\">$levent</a>";
		$eventlevellink="<a href=\"$ENV{SCRIPT_NAME}?file=$conf&log=$logShort&sort=descending&search=$search&level=$levent_level\">$levent_level</a>";

		# If the variable has Time= in it process away
		if ( $ldetails =~ /Time=/ ) {
			# Get the details in a munging variable
			$outage = $ldetails;
			
			# Get rid of the "Time=" bit
			$ldetails =~ s/Time=.*secs//g;

			# extract the time in seconds from the line.
			$outage =~ s/.*Time=(.*) secs/$1/;
			$outage = "Event Time=$outage";
		}
		else {
		 	$outage = "";
		}
		# If the variable has Time= in it process away

		if ( $ldetails =~ /tics=/ ) {
			# Get the details in a munging variable
			$tics = $ldetails;
			
			# Get rid of the "Time=" bit
			$ldetails =~ s/tics=.*$//g;

			# extract the time in seconds from the line.
			$tics =~ s/.*tics=(.*)/$1/;
			$tics = "Planned Outage TICS=$tics";
		}
		else {
		 	$tics = "";
		}

		$colspan = 1;
		$eventColor= NMIS::eventColor("$levent_level");
		$line="$ltime $nodelink $eventlink $eventlevellink $ldetails $tics $outage";
	} # if event.log 
	elsif ( (  $log =~ /nmis(.*)log/ ) and ( $line =~ / / ) ) {
		$line =~ s/  / /g;	
		@logline = split(",",$line);
		$datestamp = $logline[0];
		$lsub = $logline[1];
		$lnode = $logline[2];
		if ( $#logline > 2 ) {
			my @x;
			for $i (3..$#logline) { push(@x,$logline[$i]); }
			$levent = join(",",@x);
		}
		else {
			$levent = $logline[3];
    
		}
		$buttons=
			"<a href=\"$NMIS::config{admin}?tool=ping&node=$lnode\"><img alt=\"ping $lnode\" src=\"$NMIS::config{ping_icon}\" border=\"0\" align=\"top\"></a>".
			"<a href=\"$NMIS::config{admin}?tool=trace&node=$lnode\"><img alt=\"traceroute $lnode\" src=\"$NMIS::config{trace_icon}\" border=\"0\" align=\"top\"></a>".
			"<a href=\"telnet://$lnode\"><img alt=\"telnet to $lnode\" src=\"$NMIS::config{telnet_icon}\" border=\"0\" align=\"top\"></a>".
			"<a href=\"/cgi-nmis/nmiscgi.pl?node=$lnode\"><img alt=\"NMIS Dash\" src=\"$NMIS::config{nmis_icon}\" border=\"0\"></a> "
		;
		if ( $lnode !~ /\[(.*)\]/ ) {
			$nodelink="<a href=\"$ENV{SCRIPT_NAME}?file=$conf&log=$logShort&sort=descending&search=$lnode&lines=$lines\">$lnode</a>";
			$line =~ s/$lnode/$nodelink/g;
		}
		$line = "$datestamp $lsub $nodelink $levent";
		$colspan = 1;
		$eventColor = "#FFFFFF";
	} # elsif nmis.log 
	else {
		$eventColor = "#FFFFFF";
		$colspan = 1;
	}

	# Remove the comma's from the line
	$line =~ s/,/ /g;	

	$eventClass = eventLevelSet($levent_level);
	
	# depending on event_level print only certain things.
	if ( $level eq "" or $level =~ /normal/i or $levent_level eq "" ) {
		$print = "true";
	}
	else {
		# define which events should be displayed.
		if ( ( $level =~ /critical/i or $level =~ /fatal/i ) and ( $levent_level =~ /0|1|critical|fatal/i ) ) {
			$print = "true";
		}
		elsif ( $level =~ /major/i and ( $levent_level =~ /0|1|2|major|critical|fatal/i ) ) {
			$print = "true";
		}
		elsif ( $level =~ /minor/i and ( $levent_level =~ /0|1|2|3|minor|major|critical|fatal/i ) ) {
			$print = "true";
		}
		elsif ( $level =~ /warning/i and ( $levent_level =~ /0|1|2|3|4|warning|minor|major|critical|fatal/i ) ) {
			$print = "true";
		}
		elsif ( $level =~ /error/i and ( $levent_level =~ /0|1|2|3|4|5|error|warning|minor|major|critical|fatal/i ) ) {
			$print = "true";
		}
	}
	
	if ( $print eq "true" ) {
		print "<tr><td class=\"none\" width=\"156\">$buttons</td><td class=\"$eventClass\">$line</td></tr>\n";
		$print = "false";
	
	}

} # end outputLine

sub displayLegend {
  		print<<EOF;
<tr>
 <td class="grey">
  <table class="grey">
   <tr>
    <td class="critical">Critical</td>
    <td class="major">Major</td>
    <td class="minor">Minor</td>
    <td class="warning">Warning</td>
    <td class="error">Error</td>
    <td class="normal">Normal</td>
   </tr>
  </table>
 </td>
</tr>
EOF
}
